package com.jscape.inet.ssh.protocol.v2.marshaling;

import com.jscape.inet.ssh.protocol.messages.Message;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.StringCodec;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.Uint32Codec;
import com.jscape.inet.ssh.protocol.v2.messages.SshMsgChannelExtendedData;
import com.jscape.util.io.DataCodec;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author Alex Usun
 */
public class SshMsgChannelExtendedDataCodec
        implements DataCodec<Message> {

    @Override
    public Message read(InputStream in)
            throws IOException {
        int recipientChannel = Uint32Codec.readValue(in);
        int dataTypeCode = Uint32Codec.readValue(in);
        byte[] data = StringCodec.readValue(in);

        return new SshMsgChannelExtendedData(recipientChannel, dataTypeCode, data);
    }

    @Override
    public void write(Message value, OutputStream out)
            throws IOException {
        SshMsgChannelExtendedData message = (SshMsgChannelExtendedData) value;
        Uint32Codec.writeValue(message.recipientChannel, out);
        Uint32Codec.writeValue(message.dataTypeCode, out);
        StringCodec.writeValue(message.data, message.offset, message.length, out);
    }
}
